﻿var TMan = new N6LTimerMan();  //タイマーマネージャー
var IDTransA = new Array('sph00a', 'sph01a');
var IDTransZ = new Array('sph00z', 'sph01z');
var IDT = new Array('ln00t', 'ln01t');
var IDL = new Array('ln00l', 'ln01l');

var x3domRuntime;
var planetnum = 2;

var res;
var bBBB;
var bRunning = false;
var bWaiting = false;
var Speed = 2.5;
var Zoom = 0.2;
var Laps = 415;
var NowLaps = 0;
var Factor = 1.0;
var fFst = 1;
var dat;
var time;
var dt;
var bRead = false;
var bLAM = false;
var intvl = 50;

var CNST_AU = 1.49597870700e+11;

var planet = new Array();
var mp = new Array();
var rk = new N6LRngKt();

jQuery(document).ready(function(){
  var dta = new Date();
  setday(dta);
  F1.T4.value = 0;
  F1.T5.value = 0;
  F1.T6.value = 0;
  init(0);
  TMan.add();
  TMan.timer[0].setalerm(function() { GLoop(0); }, intvl);  //メインループセット
  onSTP();
});

//メインループ
function GLoop(id){
  if(x3domRuntime == undefined) x3domRuntime = document.getElementById('x3dabs').runtime;
  else {
    if(bBBB) bRunning = true;
    else bRunning = false;
    if(bWaiting || 0 < fFst) onWaiting();
    if(bRunning) onRunning();
  }

  TMan.timer[id].setalerm(function() { GLoop(id); }, intvl);  //メインループ再セット
}

function StringE(val){
  var str="";
  var abs = val;
  if(abs < 0.0) abs*=-1;
  var col;
  if(abs < 1) col = Math.log(abs) / Math.log(10) - 1 | 0;
  else col = Math.log(abs) / Math.log(10) | 0;
  var dig = 1;
  if(col < 0){
    for(var i = 0; i < col * -1; i++) dig /= 10;
  }
  else{
    for(var i = 0; i < col; i++) dig *= 10;
  }
  var vt = abs / dig;
  var en = 10000;
  vt *= en;
  vt = Math.floor(vt) / en;
  if(val < 0) vt *= -1;
  str = String(vt) + "e";
  if(col < 0) {str += "-"; col *= -1; str += String(col);}
  else {str += "+"; str += String(col);}
  
  return str;
}

function onNOW() {
  var dta = new Date();
  setday(dta);
  onSTP();
}

function onOO() {
  F1.T4.value = 0;
  F1.T5.value = 0;
  F1.T6.value = 0;
  onSTP();
}

function onSTP() {
  init(1);
  cont(0);
}

function onPUS() {
  cont(0);
}

function onRUN() {
  cont(1);
}

function setday(dta) {
  var year = dta.getFullYear();
  var month = dta.getMonth() + 1;
  var day = dta.getDate();
  var hour = dta.getHours();
  var minute = dta.getMinutes();
  var second = dta.getSeconds();
  F1.T1.value = year;
  F1.T2.value = month;
  F1.T3.value = day;
  F1.T4.value = hour;
  F1.T5.value = minute;
  F1.T6.value = second;
}

function settestday() {
  F1.T1.value = 2000;
  F1.T2.value = 1;
  F1.T3.value = 1;
  F1.T4.value = 0;
  F1.T5.value = 0;
  F1.T6.value = 0;
}

function setinfo() {
  var sec = 180 * 60 * 60 / Math.PI;
  if(0 < my5n - 3) F1.NWL.value = String(my5n - 3);
  else F1.NWL.value = String(0);
  F1.TTL.value = StringE(my5TH2 * sec);
  F1.AVE.value = StringE(my5TH * sec);

  var elm = document.getElementById('debug');
  elm.innerHTML = 'my5TH3:' + StringE(my5TH3) + '<br>my5TH2:' + StringE(my5TH2) + '<br>my5TH1:' + StringE(my5TH1) + '<br>my5TH:' + StringE(my5TH) + '<br>theta:' + StringE(theta) + '<br>th2:' + StringE(th2);

  if(Laps <= my5n - 3) cont(0);
}

function init(b) {
  bBBB = 0;
  if(0 <= b) Speed = Number(F1.SPD.value);
  else Speed = Number(F1.SPD.value) * -1;
  Zoom = Number(F1.ZOM.value);
  if(Zoom < 0.0) Zoom *= -1.0;
  Laps = Number(F1.LAP.value);
  if(Laps < 0.0) Laps *= -1.0;
  Factor = Number(F1.FAC.value);
  if(Factor < 0.0) Factor *= -1.0;
  NowLaps=0;

  bWaiting = false;
  InitRelative();
  onWaiting();
}

function cont(b) {
  bBBB = b;
  if(0 <= b) Speed = Number(F1.SPD.value);
  else Speed = Number(F1.SPD.value) * -1;
  Zoom = Number(F1.ZOM.value);
  if(Zoom < 0.0) Zoom *= -1.0;
  Laps = Number(F1.LAP.value);
  if(Laps < 0.0) Laps *= -1.0;
  Factor = Number(F1.FAC.value);
  if(Factor < 0.0) Factor *= -1.0;
  NowLaps=0;
}

function onWaiting() {
  if(!bWaiting) {
    fFst = -1;
    setmp();
    setline();
  }
}

function onRunning() {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;

  if(fFst != 0) {
    fFst = 0;
    time = 0.0;
    dt = Speed * 60 * 60;
  }
 
  //メインループ
  UpdateFrameRelative();
}

function getnow() {
  var nt = new Date(Number(F1.T1.value), Number(F1.T2.value) - 1, Number(F1.T3.value), Number(F1.T4.value), Number(F1.T5.value), Number(F1.T6.value));
  return nt;
}

function InitRelative() {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;
  if(!bRead) fFst = 1;
  dat = getnow();
  PlanetInit(dat);
  dt = Speed * 60 * 60;
  var pmp = new Array();
  var i;
  for(i = 0; i < planetnum; i++) pmp[i] = new N6LMassPoint(mp[i]);
  rk.Init(pmp, dt);
}

function UpdateFrameRelative() {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;

  var dat1;
  var tm = Math.abs(Speed) * msecPerDay / 1000;
  var adt = Math.abs(dt);
  var t;
  var i;

  var thth = theta;
  if(thth < 0) thth += Math.PI * 2

  if(dt != 0.0) {
    if(4 <= my5n){
      if(thth - 0.01 < th2 && th2 < thth + 0.05) { if(!flg1){ flg1 = true; flg2 = false; dt /= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
      else { if(!flg2){ flg2 = true; flg1 = false; dt *= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
    }
    else {
      if(!flg1){ flg1 = true; flg2 = false; dt /= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }
      else { if(!flg2){ flg2 = true; flg1 = false; dt *= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
    }
    t = adt;
    while(t <= tm) {
      if(4 <= my5n){
        if(thth - 0.01 < th2 && th2 < thth + 0.05) { if(!flg1){ flg1 = true; flg2 = false; dt /= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
        else { if(!flg2){ flg2 = true; flg1 = false; dt *= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
      }
      else {
        if(!flg1){ flg1 = true; flg2 = false; dt /= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }
        else { if(!flg2){ flg2 = true; flg1 = false; dt *= 100000; adt = Math.abs(dt); rk.Init(mp, dt); }}
      }

      time = time + dt * 1000;
      //質点アップデート
      rk.UpdateFrame()

      //太陽原点補正
      for(i = 1; i < planetnum; i++) {
        rk.mp[i].x = rk.mp[i].x.Sub(rk.mp[0].x);
        mp[i].x = new N6LVector(rk.mp[i].x);
        mp[i].x0 = new N6LVector(rk.mp[i].x0);
        mp[i].v = new N6LVector(rk.mp[i].v);
      }
      rk.mp[0].x = rk.mp[0].x.ZeroVec();
      mp[0].x = new N6LVector(rk.mp[0].x);
      mp[0].x0 = new N6LVector(rk.mp[0].x0);
      mp[0].v = new N6LVector(rk.mp[0].v);

      my5X1 = rk.mp[1].x.x[0] - rk.mp[0].x.x[0];
      my5Y1 = rk.mp[1].x.x[1] - rk.mp[0].x.x[1];
      my5R = Abs2(my5X1,my5Y1);
      my5T = time;

      //近日点判定
      alt = my5R;
      th2 = Math.atan2(my5Y1 , my5X1);
      if(th2 < 0) th2 = th2 + Math.PI * 2.0;
      var bbb = false;
      var ccc = false;
      var ddd = false;
      var eee = false;

      if(hialt2 <= alt && rgt == true){
          if(alt <= my5A + dd){
              ccc = true;
              rgt = false;
              if(rgt2 == true){
                  rgt2 = false;
                  bbb = true;
                  my5RA1tmp = alt;
              }
          }
      }
      else if(alt < hialt2 && rgt == false){
          rgt = true;
          if(my5A - dd < alt && rgt2 == false){
              rgt2 = true;
              rgt4 = true;
              hialttmp = alt;
              thetatmp = theta;
              my5RA2tmp = alt;
          }
      }
      if(ccc == true){
           if(alt < hialttmp){
               hialttmp = alt;
               thetatmp = th2;
           }
      }
      if(rgt4 == true && rgt2 == false && (th2 < theta - 0.5 || theta + 0.5 < th2)){
          eee = true;
          my5n = my5n + 1.0;
          rgt4 = false;
           hialt = hialttmp;
           if(my5n == 1.0){
               my5n = my5n + 1.0;
               theta3 = thetatmp;
               theta2 = 0.0;
               thetatmp = 0.0;
           }
           else if(2.0 < my5n){
               theta = thetatmp - theta2 - theta3;
               theta2 = thetatmp - theta3;
           }

      }   
      hialt2 = alt;

      if(3.0 == my5n){
          my5BDP = true;
      }

      if(my5BDP == true){
          theta2 = theta2 % (Math.PI * 2.0);
          my5TH2 = theta2 - my5TH3;
          theta = theta % (Math.PI * 2.0);
          my5TH1 = theta - my5TH3;
          if(my5n - 2.0 == 1 && my5TH3 == 0.0) { my5TH3 = my5TH2; my5TH = 0; my5TH1 = 0; my5TH2 = 0;}
          else my5TH = (theta2 - my5TH3) / (my5n - 3.0);
          my5TH = my5TH % (Math.PI * 2.0);
      }
      t += adt;
    }

    var datt = dat.getTime();
    var dat1t = datt + time;
    var dat1 = new Date(dat1t);
    setmp();
    setday(dat1);
    setinfo();
  } 
}

function setmp() {
  var i;
  for(i = 0; i < planetnum; i++) {
    var elm = document.getElementById(IDTransA[i]);
    var sp = new x3dom.fields.SFVec3f(mp[i].x.x[1] / CNST_AU / Zoom, -mp[i].x.x[0] / CNST_AU / Zoom, mp[i].x.x[2] / CNST_AU / Zoom);
    elm.setAttribute('translation', sp.toString());
  }
}

function def(){
  my5AU = 1.49597870700e+11;
  my5AU3 = 60.0 * 60.0 * 24.0 * 365.24;
  my5AU2 = 2.0 * Math.PI * my5AU / my5AU3;
  my5X1 = rk.mp[1].x.x[0] - rk.mp[0].x.x[0];
  my5Y1 = rk.mp[1].x.x[1] - rk.mp[0].x.x[1];
  my5R = Abs2(my5X1,my5Y1);
  my5A = planet[1].m_a * my5AU;
  my5T = 0;
  my5RA1 = planet[1].m_ra * my5AU;
  my5RA2 = planet[1].m_rb * my5AU;
  my5RA1tmp = 0;
  my5RA2tmp = 0;
  my5Atmp = 0;
  my5BDP = false;

  my5n = 0;
  dd = (my5RA2 + my5RA1) / 2.0;
  rgt = true;
  rgt2 = true;
  rgt3 = true;
  rgt4 = true;
  theta = 0;
  theta2 = 0;
  theta3 = 0;
  hialt = my5RA2;
  hialt2 = my5RA2;
  hialttmp = hialt2;
  thetatmp = 0;
  alt = my5R;
  th2 = 0;

  flg1 = false;
  flg2 = false;

  my5TH3 = 0;
  my5TH2 = 0;
  my5TH1 = 0;
  my5TH = 0;
}

//惑星初期化
function PlanetInit(dat) {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;
  var i;
  var j;


  if(0 < fFst) {
    //データファイル読み込み
    if(!bWaiting) {
      bWaiting = true;
      readCSV('./javascripts/nas6lib/PData000.txt', 'analyzeCSV', 'readedCSV');
    }
    return;
  }
  else {
    for(i = 0; i < planetnum; i++) {
      var dat0 = planet[i].m_dat0;
      var datt = dat.getTime();
      var dat0t = dat0.getTime();
      var ddat = (datt - dat0t) / msecPerDay;
      var nday = ddat;

      var xx = new Array(new N6LVector(3));
      var f = planet[i].kepler(nday, xx);
      planet[i].x0 = new N6LVector(3);
      planet[i].x0.x[0] = xx[0].x[0];
      planet[i].x0.x[1] = xx[0].x[1];
      planet[i].x0.x[2] = 0.0;

      var xyz = new Array(new N6LVector(3));
      planet[i].ecliptic(planet[i].x0.x[0], planet[i].x0.x[1], planet[i].x0.x[2], xyz);
      if(isNaN(xyz[0].x[0]) || isNaN(xyz[0].x[1]) || isNaN(xyz[0].x[2])) {
        planet[i].x0.x[0] = 0.0;
        planet[i].x0.x[1] = 0.0;
        planet[i].x0.x[2] = 0.0;
      }
      else {
        planet[i].x0.x[0] = xyz[0].x[0];
        planet[i].x0.x[1] = xyz[0].x[1];
        planet[i].x0.x[2] = xyz[0].x[2];
      }

      planet[i].v0 = new N6LVector(3);
      
      //ケプラー方程式から軌道速度を求める
      var xyz2 = new Array(new N6LVector(3));

      var xxx = new Array(new N6LVector(3));
      planet[i].kepler(nday + (1.0 / (24.0 * 4.0) * planet[i].m_t), xxx);
      var vv = xxx[0].Sub(xx[0]);
      //速度微調整
      planet[i].v0.x[0] = (vv.x[0] / (60.0 * 60.0 * 24.0 / (24.0 * 4.0) * planet[i].m_t) / planet[i].CNST_C) * planet[i].m_mv;
      planet[i].v0.x[1] = (vv.x[1] / (60.0 * 60.0 * 24.0 / (24.0 * 4.0) * planet[i].m_t) / planet[i].CNST_C) * planet[i].m_mv;
      planet[i].v0.x[2] = 0.0;

      planet[i].ecliptic(planet[i].v0.x[0], planet[i].v0.x[1], planet[i].v0.x[2], xyz2);
      if(isNaN(xyz2[0].x[0]) || isNaN(xyz2[0].x[1]) || isNaN(xyz2[0].x[2])) {
        planet[i].v0.x[0] = 0.0;
        planet[i].v0.x[1] = 0.0;
        planet[i].v0.x[2] = 0.0;
      }
      else {
        planet[i].v0.x[0] = xyz2[0].x[0];
        planet[i].v0.x[1] = xyz2[0].x[1];
        planet[i].v0.x[2] = xyz2[0].x[2];
      }
      mp[i] = new N6LMassPoint(planet[i].x0, planet[i].v0, planet[i].m_m, planet[i].m_r, planet[i].m_e);
    }
    def();
  }
}

function readedCSV(res) {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;
  bWaiting = false;
  bRead = true;

  for(i = 0; i < planetnum; i++) {

    var PlanetName = res[i][0];
    var PlanetNo = Number(res[i][1]);
    var EpochYY = Number(res[i][2]);
    var EpochMM = Number(res[i][3]);
    var EpochDD = Number(res[i][4]);
    var Epochh = Number(res[i][5]);
    var Epochm = Number(res[i][6]);
    var Epochs = Number(res[i][7]);
    var a = Number(res[i][8]);
    var e = Number(res[i][9]);
    var m0 = Number(res[i][10]);
    var npd = Number(res[i][11]);
    var ra = Number(res[i][12]);
    var rb = Number(res[i][13]);
    var p = Number(res[i][14]);
    var ss = Number(res[i][15]);
    var ii = Number(res[i][16]);
    var ww = Number(res[i][17]);
    var m = Number(res[i][18]);
    var r = Number(res[i][19]);
    var mv = Number(res[i][20]);

    var dat0 = new Date(EpochYY, EpochMM - 1, EpochDD, Epochh, Epochm, Epochs);
    var datt = dat.getTime();
    var dat0t = dat0.getTime();

    var ddat = (datt - dat0t) / msecPerDay;

    //惑星初期化
    planet[i] = new N6LPlanet();
    planet[i].Create(PlanetNo, PlanetName, ddat, dat0, a, e, m0, npd, ra, rb, p, ss, ii, ww, m, r, mv);

    //質点初期化
    mp[i] = new N6LMassPoint(planet[i].x0, planet[i].v0, m, r, e);
  }
  def();
  return true;
}

//惑星軌道線分設定
function setline() {
  var msecPerMinute = 1000 * 60;
  var msecPerHour = msecPerMinute * 60;
  var msecPerDay = msecPerHour * 24;
  var i;
  var j;
  var k;
  var n = 32;
  var str;
  for(i = 1; i < planetnum; i++) {
    str = "";
    var x0;
    //惑星１周を32分割の線分設定
    for(j = 0; j < n; j++) {
      var ad = (360.0 * 360.0 / 365.2425 / planet[i].m_nperday) * (j / n);
      var days = (dat.getTime() - planet[i].m_dat0.getTime()) / msecPerDay;
      var nday = days + ad;
      var xx = new Array(new N6LVector(3));
      var f = planet[i].kepler(nday, xx);
      var x1 = new N6LVector(3);
      x1.x[0] = xx[0].x[0];
      x1.x[1] = xx[0].x[1];
      x1.x[2] = 0.0;
      if(j == 0) x0 = new N6LVector(x1);
      str += (x1.x[1] / CNST_AU / Zoom).toString() + " " + (-x1.x[0] / CNST_AU / Zoom).toString() + ", ";
    }
    str += (x0.x[1] / CNST_AU / Zoom).toString() + " " + (-x0.x[0] / CNST_AU / Zoom).toString();

    var ss = planet[i].m_s * planet[i].CNST_DR;
    var ii = planet[i].m_i * planet[i].CNST_DR;
    var ww = planet[i].m_w * planet[i].CNST_DR;

    var vec = new N6LVector(3);
    var mat = new N6LMatrix(3);
    mat = mat.UnitMat().RotAxis(vec.UnitVec(2), ss).RotAxis(vec.UnitVec(1).Mul(-1.0), ii).RotAxis(vec.UnitVec(2), ww);
    var VecWK = new N6LVector(4);
    var MatWK = new N6LMatrix(4);
    MatWK.x[0] = VecWK.UnitVec(0);
    MatWK.x[0].bHomo = false;
    for(k = 1; k < 4; k++) {
      MatWK.x[k] = mat.x[k - 1].NormalVec().ToHomo();
      MatWK.x[k].x[0] = 0.0;
      MatWK.x[k].bHomo = false;
    }
    VecWK = MatWK.NormalMat().Vector();


    var elm;
    var sp;

    elm = document.getElementById(IDL[i]);
    elm.setAttribute('lineSegments', new String(str));

    elm = document.getElementById(IDT[i]);
    sp = VecWK.ToX3DOM();
    elm.setAttribute('rotation', sp.toString());
  }
}


     //schwartz correction term//シュワルツシルト補正項
    N6LRngKt.prototype.ToSchwartz = function(v) {
        return Factor * v * v;
    };

//絶対値二乗
function SqAbs2(x,y){
    return (x * x + y * y);
}

//絶対値
function Abs2(x,y){
    return (Math.sqrt(SqAbs2(x,y)));
}
